clear all
close all
clc


tic
vr='00:00';
gt=datetime(vr,'Format','HH:mm');
gtu=gt+minutes(0:1:1439);

december1=xlsread('dati giorno per giorno_davi1','inverter 1 trasposto','LY2:NC1441');
%controllo che non ci siano NaN nel mese considerato%
for h=1:31
    for t=1:1440
        
        if isnan(december1(t,h))
            december1(t,h)=0; %metto zero dove ci sono NaN
        end
    end
end

december1(:,19)=december1(:,17);



for h=1:31
    for t=1:1440
        
        
            december1(t,h)=december1(t,h)*4/4.2; %riduco produzione FV
        
    end
end



generazione=sum(december1)/(60*1000);
%analisi produzione fotovoltaica
prima_parte_giornata=6; %% indichiamo l'ora in cui finisce la prima parte della giornata
seconda_parte_giornata=18; %% indichiamo l'ora in cui finisce la seconda parte della giornata
prod_prima_parte_giornata=sum(december1(1:(prima_parte_giornata*60),:))/60/1000; %%kWh prodotti al giorno
prod_seconda_parte_giornata=sum(december1(prima_parte_giornata*60+1:(seconda_parte_giornata*60),:))/60/1000; %%kWh prodotti al giorno
prod_terza_parte_giornata=sum(december1(seconda_parte_giornata*60+1:end,:))/60/1000; %%kWh prodotti al giorno
suddivisione_prod=[prod_prima_parte_giornata;prod_seconda_parte_giornata;prod_terza_parte_giornata];
prod_december=(reshape(december1, [44640,1]))/1000;


cons_agosto=xlsread('agosto_2','C2:C44641');
mese_agosto=reshape(cons_agosto,[1440 31]);
load1=sum(mese_agosto)/60;

mese_agosto(:,19)=mese_agosto(:,17);



caricodicembre=sum(mese_agosto);

%%INPUTS
primo_giorno_mese=2;  % 1 equivale a lunedi
giorni_del_mese_considerato=31;
prima_parte_giornata=6; %% indichiamo l'ora in cui finisce la prima parte della giornata
seconda_parte_giornata=18; %% indichiamo l'ora in cui finisce la seconda parte della giornata

%%ANALISI CARICO PER PREVISIONE
%profilo_consumo_agosto=agosto;
%mese_agosto=vec2mat(profilo_consumo_agosto,1440)';%
carico_giornaliero=sum(mese_agosto)/60; %%kWh consumati al giorno
carico_prima_parte_giornata=sum(mese_agosto(1:(prima_parte_giornata*60),:))/60; %%kWh consumati al giorno
carico_seconda_parte_giornata=sum(mese_agosto(prima_parte_giornata*60+1:(seconda_parte_giornata*60),:))/60; %%kWh consumati al giorno
carico_terza_parte_giornata=sum(mese_agosto(seconda_parte_giornata*60+1:end,:))/60; %%kWh consumati al giorno
suddivisione_carico=[carico_prima_parte_giornata;carico_seconda_parte_giornata;carico_terza_parte_giornata];
feriali=suddivisione_carico;
festivi=suddivisione_carico;
 %%catalogazione giorni
 catalogazione_giorni(1)=primo_giorno_mese;
for contgiorni=2:giorni_del_mese_considerato
    catalogazione_giorni(contgiorni)=catalogazione_giorni(contgiorni-1)+1;
    if catalogazione_giorni(contgiorni)==8
        catalogazione_giorni(contgiorni)=1;
    end
end

%faccio una divisione feriale festivo
for cont_fer_fest=1:giorni_del_mese_considerato
    if catalogazione_giorni(cont_fer_fest)==6 || catalogazione_giorni(cont_fer_fest)==7
    feriali(:,cont_fer_fest)=[0,0,0];
    else
    festivi(:,cont_fer_fest)=[0,0,0];
    end
end
%dati utili per la rpevisione del carico
carico_medio_festivo=mean(festivi');
carico_medio_feriale=mean(feriali');

caricoago=zeros(4,31);
caricoago(1,1)=primo_giorno_mese;
for contgiorni=2:giorni_del_mese_considerato
    caricoago(1,contgiorni)=caricoago(1,contgiorni-1)+1;
    if caricoago(1,contgiorni)==8
        caricoago(1,contgiorni)=1;
    end
end

for cont_i=1:1:31
    if caricoago(1,cont_i)==6 || caricoago(1,cont_i)==7
        caricoago(2,cont_i)=carico_medio_festivo(1);
        caricoago(3,cont_i)=carico_medio_festivo(2);
        caricoago(4,cont_i)=carico_medio_festivo(3);
    else
        caricoago(2,cont_i)=carico_medio_feriale(1);
        caricoago(3,cont_i)=carico_medio_feriale(2);
        caricoago(4,cont_i)=carico_medio_feriale(3);
    end
end

bilancioprod=zeros(3,31);
%bilancio nelle tre fasce 0-6 6-18 18-24%
for t=1:31
    for s=1:3
        
       bilancioprod(s,t)=suddivisione_prod(s,t)-suddivisione_carico(s,t);
    end
end

for cont_i=1:1:31
    if bilancioprod(2,cont_i)>0
        bilancioprod(2,cont_i)=bilancioprod(2,cont_i)*0.9;
    end
    if bilancioprod(2,cont_i)<0
        bilancioprod(2,cont_i)=bilancioprod(2,cont_i)/0.9;
    end
end

pbat=zeros(44640,1); %potenza batteria
pgrid=zeros(44640,1); %potenza rete
Ebatdis18=zeros(1,30); %energia contenuta nella batteria alle 18
SOC=zeros(44640,1); %stato di carica
Pmax=4; %potenza massima batteria
Cbat=2; %capacit batteria
P_peak=2; %soglia per uso rete
k=1; %contatore giorni
pbat1=zeros(44640,1);
pgrid1=zeros(44640,1);
SOC1=zeros(44640,1);
selectSOCmin=0.2;
etacd=0.88; %rendimento carica e scarica
%%ciclo MAIN
rapp_prod_carico=zeros(1,31);
rapp_PVbat_carico=0.5;

for cont_i=1:1:31
    rapp_prod_carico(cont_i)=suddivisione_prod(2,cont_i)/suddivisione_carico(2,cont_i);
end



% Fino alle 18 del primo giorno utilizzo la strategia tradizionale
for minuto=1:1:seconda_parte_giornata*60
    
    pbat(minuto)=prod_december(minuto)-cons_agosto(minuto);
    
    if pbat(minuto)>Pmax
        pgrid(minuto)=pbat(minuto)-Pmax;
        
        pbat(minuto)=Pmax;
    end
    
    if pbat(minuto)<-Pmax
        pbat(minuto)=-Pmax;
        pgrid(minuto)=prod_december(minuto)-cons_agosto(minuto)+Pmax;
    end
    
    if pbat(minuto)>=0
    if minuto==1
        SOC(minuto)=1+(etacd/(60*Cbat))*(pbat(minuto));
    else
        SOC(minuto)=SOC(minuto-1)+(etacd/(60*Cbat))*(pbat(minuto));
    end
    elseif pbat(minuto)<0
    if minuto==1
        SOC(minuto)=1+(1/(etacd*60*Cbat))*(pbat(minuto));
    else
        SOC(minuto)=SOC(minuto-1)+(1/(etacd*60*Cbat))*(pbat(minuto));
    end
    end
    
    
    
    
    if SOC(minuto)>1
        
        
        if minuto==1
            pbat(minuto)=0;
        else
            pbat(minuto)=(1-SOC(minuto-1))*Cbat*(60/etacd);
        end
        pgrid(minuto)=pgrid(minuto)+(SOC(minuto)-1)*Cbat*(60/etacd);
        SOC(minuto)=1;
        
    end
    
    if SOC(minuto)<selectSOCmin
        
        if minuto==1
            pbat(minuto)=(selectSOCmin-1)*Cbat*60*etacd;
        else
            pbat(minuto)=(selectSOCmin-SOC(minuto-1))*Cbat*60*etacd;
        end
        
        
        pgrid(minuto)=pgrid(minuto)+(SOC(minuto)-selectSOCmin)*Cbat*60*etacd;
        SOC(minuto)=selectSOCmin;
    end
end


for minuto=seconda_parte_giornata*60:1440:seconda_parte_giornata*60+1440*(giorni_del_mese_considerato-2)
    
    Ebatdis18(k)=(SOC(minuto)-selectSOCmin)*Cbat; %energia disponibile per la scarica nella batteria alle 18
    giorno=ceil(minuto/1440); %identifico il giorno
  
    %controllo il bilancio 6-18 del giorno dopo e verifico l'energia
    %contenuta alle 6 del mattino dopo dentro la batteria%
    
   
    
    
    SOCin=SOC(minuto);
    %caso1 bilancio 6-18 del giorno dopo positivo e carica ancora presente alle 6 del giorno dopo 
    if bilancioprod(2,giorno+1)>0 && Ebatdis18(k)+bilancioprod(3,giorno)+bilancioprod(1,giorno+1)>0
        SOCmin=selectSOCmin;
        
        for cont_i=minuto+1:minuto+1440
            
    [pbatf,pgridf,SOCfin]=function_storage(SOCmin,SOCin,prod_december(cont_i),cons_agosto(cont_i),Cbat,Pmax,etacd);
        pbat(cont_i)=pbatf;
        pgrid(cont_i)=pgridf;
        SOC(cont_i)=SOCfin;
        SOCin=SOCfin;
        
        
        end
    end
    
    %caso2 bilancio 6-18 del giorno dopo positivo e carica non pi presente alle 6 del giorno dopo
    if bilancioprod(2,giorno+1)>0 && Ebatdis18(k)+bilancioprod(3,giorno)+bilancioprod(1,giorno+1)<0
        ratio_prod_load=(Ebatdis18(k)+suddivisione_prod(3,giorno)+suddivisione_prod(1,giorno+1))/(suddivisione_carico(3,giorno)+suddivisione_carico(1,giorno+1));
            if ratio_prod_load>rapp_PVbat_carico %distribuisco carica prop al consumo nella batteria tra 6pmcd e 6amda
    for cont_i=minuto+1:minuto+prima_parte_giornata*60
    %aggiorno il SOC minimo
    if Ebatdis18(k)==0
       SOCmin=selectSOCmin;
    else
    SOCmin=(Cbat*selectSOCmin+Ebatdis18(k)-(bilancioprod(3,giorno)/(bilancioprod(3,giorno)+bilancioprod(1,giorno+1)))*Ebatdis18(k))/Cbat;
    end
    
    
        [pbatf,pgridf,SOCfin]=function_storage1(SOCmin,SOCin,prod_december(cont_i),cons_agosto(cont_i),Cbat,Pmax,etacd,P_peak);
        pbat(cont_i)=pbatf;
        pgrid(cont_i)=pgridf;
        SOC(cont_i)=SOCfin;
        SOCin=SOCfin; 
    end 
          
         for cont_i=minuto+prima_parte_giornata*60+1:minuto+1440
         SOCmin=selectSOCmin;
        [pbatf,pgridf,SOCfin]=function_storage1(SOCmin,SOCin,prod_december(cont_i),cons_agosto(cont_i),Cbat,Pmax,etacd,P_peak);
        pbat(cont_i)=pbatf;
        pgrid(cont_i)=pgridf;
        SOC(cont_i)=SOCfin;
        SOCin=SOCfin; 
             
      
         end
            else % peak shaving tra 6pmcd e 6amda
              for cont_i=minuto+1:minuto+prima_parte_giornata*60*2
     if cons_agosto(cont_i)>P_peak && cons_agosto(cont_i)>prod_december(cont_i)
        if prod_december(cont_i)<=P_peak
            pgrid(cont_i)=prod_december(cont_i)-P_peak;
            pbat(cont_i)=P_peak-cons_agosto(cont_i);
            if pbat(cont_i)<-Pmax
                pbat(cont_i)=-Pmax;
                pgrid(cont_i)=pgrid(cont_i)-cons_agosto(cont_i)+P_peak+Pmax;
            end
            SOC(cont_i)=SOC(cont_i-1)+(1/(etacd*60*Cbat))*(pbat(cont_i));
            if SOC(cont_i)<selectSOCmin
                pbat(cont_i)=(selectSOCmin-SOC(cont_i-1))*Cbat*60*etacd;
                pgrid(cont_i)=pgrid(cont_i)+(SOC(cont_i)-selectSOCmin)*Cbat*60*etacd;
                SOC(cont_i)=selectSOCmin;
            end
        else
            pbat(cont_i)=prod_december(cont_i)-cons_agosto(cont_i);
            if pbat(cont_i)<-Pmax
                pbat(cont_i)=-Pmax;
                pgrid(cont_i)=prod_december(cont_i)-cons_agosto(cont_i)+Pmax;
            end
            SOC(cont_i)=SOC(cont_i-1)+(1/(etacd*60*Cbat))*(pbat(cont_i));
            if SOC(cont_i)<selectSOCmin
                pbat(cont_i)=(selectSOCmin-SOC(cont_i-1))*Cbat*60*etacd;
                pgrid(cont_i)=pgrid(cont_i)+(SOC(cont_i)-selectSOCmin)*Cbat*60*etacd;
                SOC(cont_i)=selectSOCmin;
            end
        end
        
        
        
        
    end
    if cons_agosto(cont_i)<=P_peak && cons_agosto(cont_i)>prod_december(cont_i)
        pbat(cont_i)=0;
        SOC(cont_i)=SOC(cont_i-1);
        pgrid(cont_i)=prod_december(cont_i)-cons_agosto(cont_i);
    end
    if cons_agosto(cont_i)<prod_december(cont_i)
        pbat(cont_i)=prod_december(cont_i)-cons_agosto(cont_i);
        SOC(cont_i)=SOC(cont_i-1)+(etacd/(60*Cbat))*(pbat(cont_i));
        if SOC(cont_i)>1
            pbat(cont_i)=(1-SOC(cont_i-1))*Cbat*(60/etacd);
             pgrid(cont_i)=pgrid(cont_i)+(SOC(cont_i)-1)*Cbat*(60/etacd);
             SOC(cont_i)=1;
        end
        
        
    end
    if cons_agosto(cont_i)==prod_december(cont_i)
        pbat(cont_i)=0;
        pgrid(cont_i)=0;
        SOC(cont_i)=SOC(cont_i-1);
    end
    
    
              end
              SOCin=SOC(minuto+720);
              SOCmin=selectSOCmin;
              for cont_i=minuto+721:minuto+1440
        [pbatf,pgridf,SOCfin]=function_storage(SOCmin,SOCin,prod_december(cont_i),cons_agosto(cont_i),Cbat,Pmax,etacd);
        pbat(cont_i)=pbatf;
        pgrid(cont_i)=pgridf;
        SOC(cont_i)=SOCfin;
        SOCin=SOCfin;
              end
            end
    end
    
   %caso3 bilancio 6-18 del giorno dopo negativo e rapporto produzione
     %carico 6-18 minore di 0.7: soddisfo solo picchi di carico fino alle 6 di
     %due giorni dopo
    if bilancioprod(2,giorno+1)<0 
        Ebatdis6=Ebatdis18(k)+bilancioprod(3,giorno)+bilancioprod(1,giorno+1);
        if Ebatdis6<0
            Ebatdis6=0;
        end
        if Ebatdis6/suddivisione_carico(2,giorno+1)+rapp_prod_carico(giorno+1)<rapp_PVbat_carico
        
        
    for cont_i=minuto+1:minuto+1440
            
    if cons_agosto(cont_i)>P_peak && cons_agosto(cont_i)>prod_december(cont_i)
        if prod_december(cont_i)<=P_peak
            pgrid(cont_i)=prod_december(cont_i)-P_peak;
            pbat(cont_i)=P_peak-cons_agosto(cont_i);
            if pbat(cont_i)<-Pmax
                pbat(cont_i)=-Pmax;
                pgrid(cont_i)=pgrid(cont_i)-cons_agosto(cont_i)+P_peak+Pmax;
            end
            SOC(cont_i)=SOC(cont_i-1)+(1/(etacd*60*Cbat))*(pbat(cont_i));
            if SOC(cont_i)<selectSOCmin
                pbat(cont_i)=(selectSOCmin-SOC(cont_i-1))*Cbat*60*etacd;
                pgrid(cont_i)=pgrid(cont_i)+(SOC(cont_i)-selectSOCmin)*Cbat*60*etacd;
                SOC(cont_i)=selectSOCmin;
            end
        else
            pbat(cont_i)=prod_december(cont_i)-cons_agosto(cont_i);
            if pbat(cont_i)<-Pmax
                pbat(cont_i)=-Pmax;
                pgrid(cont_i)=prod_december(cont_i)-cons_agosto(cont_i)+Pmax;
            end
            SOC(cont_i)=SOC(cont_i-1)+(1/(etacd*60*Cbat))*(pbat(cont_i));
            if SOC(cont_i)<selectSOCmin
                pbat(cont_i)=(selectSOCmin-SOC(cont_i-1))*Cbat*60*etacd;
                pgrid(cont_i)=pgrid(cont_i)+(SOC(cont_i)-selectSOCmin)*Cbat*60*etacd;
                SOC(cont_i)=selectSOCmin;
            end
        end
        
        
        
        
    end
    if cons_agosto(cont_i)<=P_peak && cons_agosto(cont_i)>prod_december(cont_i)
        pbat(cont_i)=0;
        SOC(cont_i)=SOC(cont_i-1);
        pgrid(cont_i)=prod_december(cont_i)-cons_agosto(cont_i);
    end
    if cons_agosto(cont_i)<prod_december(cont_i)
        pbat(cont_i)=prod_december(cont_i)-cons_agosto(cont_i);
        SOC(cont_i)=SOC(cont_i-1)+(etacd/(60*Cbat))*(pbat(cont_i));
        if SOC(cont_i)>1
            pbat(cont_i)=(1-SOC(cont_i-1))*Cbat*(60/etacd);
             pgrid(cont_i)=pgrid(cont_i)+(SOC(cont_i)-1)*Cbat*(60/etacd);
             SOC(cont_i)=1;
        end
        
        
    end
    if cons_agosto(cont_i)==prod_december(cont_i)
        pbat(cont_i)=0;
        pgrid(cont_i)=0;
        SOC(cont_i)=SOC(cont_i-1);
    end
    
    
    end
        
        end
    end
   
     
    
    
    
    
     %caso4 bilancio 6-18 del giorno dopo negativo e rapporto produzione
     %carico 6-18 maggiore di 0.7: distribuisco la carica fino alle 6 di
     %due giorni dopo
    if bilancioprod(2,giorno+1)<0
         Ebatdis6=Ebatdis18(k)+bilancioprod(3,giorno)+bilancioprod(1,giorno+1);
        if Ebatdis6<0
            Ebatdis6=0;
        end
        if Ebatdis6/suddivisione_carico(2,giorno+1)+rapp_prod_carico(giorno+1)>rapp_PVbat_carico
       for cont_i=minuto+1:minuto+prima_parte_giornata*60
           if Ebatdis18(k)==0
               SOCmin=selectSOCmin;
           else
          SOCmin=(Cbat*selectSOCmin+Ebatdis18(k)-(bilancioprod(3,giorno)/(bilancioprod(3,giorno)+bilancioprod(1,giorno+1)+bilancioprod(2,giorno+1)+bilancioprod(3,giorno+1)+bilancioprod(1,giorno+2)))*Ebatdis18(k))/Cbat;
           end
          
        [pbatf,pgridf,SOCfin]=function_storage1(SOCmin,SOCin,prod_december(cont_i),cons_agosto(cont_i),Cbat,Pmax,etacd,P_peak);
        pbat(cont_i)=pbatf;
        pgrid(cont_i)=pgridf;
        SOC(cont_i)=SOCfin;
        SOCin=SOCfin;
       end    
      
       for cont_i=minuto+prima_parte_giornata*60+1:minuto+prima_parte_giornata*60*2
           if Ebatdis18(k)==0
               SOCmin=selectSOCmin;
           else
          SOCmin=(Cbat*selectSOCmin+Ebatdis18(k)-(bilancioprod(3,giorno)/(bilancioprod(3,giorno)+bilancioprod(1,giorno+1)+bilancioprod(2,giorno+1)+bilancioprod(3,giorno+1)+bilancioprod(1,giorno+2)))*Ebatdis18(k)-(bilancioprod(1,giorno+1)/(bilancioprod(3,giorno)+bilancioprod(1,giorno+1)+bilancioprod(2,giorno+1)+bilancioprod(3,giorno+1)+bilancioprod(1,giorno+2)))*Ebatdis18(k))/Cbat;
           end
           
        [pbatf,pgridf,SOCfin]=function_storage1(SOCmin,SOCin,prod_december(cont_i),cons_agosto(cont_i),Cbat,Pmax,etacd,P_peak);
        pbat(cont_i)=pbatf;
        pgrid(cont_i)=pgridf;
        SOC(cont_i)=SOCfin;
        SOCin=SOCfin;
        
       end    
        
     for cont_i=minuto+prima_parte_giornata*60*2+1:minuto+1440
         if Ebatdis18(k)==0
               SOCmin=selectSOCmin;
           else
         SOCmin=(Cbat*selectSOCmin+Ebatdis18(k)-(bilancioprod(3,giorno)/(bilancioprod(3,giorno)+bilancioprod(1,giorno+1)+bilancioprod(2,giorno+1)+bilancioprod(3,giorno+1)+bilancioprod(1,giorno+2)))*Ebatdis18(k)-(bilancioprod(1,giorno+1)/(bilancioprod(3,giorno)+bilancioprod(1,giorno+1)+bilancioprod(2,giorno+1)+bilancioprod(3,giorno+1)+bilancioprod(1,giorno+2)))*Ebatdis18(k)-(bilancioprod(2,giorno+1)/(bilancioprod(3,giorno)+bilancioprod(1,giorno+1)+bilancioprod(2,giorno+1)+bilancioprod(3,giorno+1)+bilancioprod(1,giorno+2)))*Ebatdis18(k))/Cbat;
          end
         [pbatf,pgridf,SOCfin]=function_storage1(SOCmin,SOCin,prod_december(cont_i),cons_agosto(cont_i),Cbat,Pmax,etacd,P_peak);
        pbat(cont_i)=pbatf;
        pgrid(cont_i)=pgridf;
        SOC(cont_i)=SOCfin;
        SOCin=SOCfin;
         
     end
     
     
     
        
        end
    end
    
    
    %check per vedere se mi trovo nel caso 4
    if k>=2 && giorno>1
    if bilancioprod(2,giorno)<0 && bilancioprod(2,giorno-1)>0
            
        Ebatdis6=Ebatdis18(k-1)+bilancioprod(3,giorno-1)+bilancioprod(1,giorno);
        if Ebatdis6<0
            Ebatdis6=0;
        end
        if Ebatdis6/suddivisione_carico(2,giorno)+rapp_prod_carico(giorno)>rapp_PVbat_carico
            
            
            SOCin=SOC(minuto);
            for cont_i=minuto+1:minuto+prima_parte_giornata*60
                
               if Ebatdis18(k-1)==0
                   SOCmin=selectSOCmin;
               else
          SOCmin=(Cbat*selectSOCmin+Ebatdis18(k-1)-(bilancioprod(2,giorno)/(bilancioprod(3,giorno)+bilancioprod(1,giorno+1)+bilancioprod(2,giorno)+bilancioprod(1,giorno)+bilancioprod(3,giorno-1)))*Ebatdis18(k-1)-(bilancioprod(1,giorno)/(bilancioprod(3,giorno)+bilancioprod(1,giorno+1)+bilancioprod(2,giorno)+bilancioprod(1,giorno)+bilancioprod(3,giorno-1)))*Ebatdis18(k-1)-(bilancioprod(3,giorno-1)/(bilancioprod(3,giorno)+bilancioprod(1,giorno+1)+bilancioprod(2,giorno)+bilancioprod(1,giorno)+bilancioprod(3,giorno-1)))*Ebatdis18(k-1)-(bilancioprod(3,giorno)/(bilancioprod(3,giorno)+bilancioprod(1,giorno+1)+bilancioprod(2,giorno)+bilancioprod(1,giorno)+bilancioprod(3,giorno-1)))*Ebatdis18(k-1))/Cbat;
               end
              
           [pbatf,pgridf,SOCfin]=function_storage1(SOCmin,SOCin,prod_december(cont_i),cons_agosto(cont_i),Cbat,Pmax,etacd,P_peak);
        pbat(cont_i)=pbatf;
        pgrid(cont_i)=pgridf;
        SOC(cont_i)=SOCfin;
        SOCin=SOCfin;
            end
             
            for cont_i=minuto+prima_parte_giornata*60+1:minuto+1440
                SOCmin=selectSOCmin;
             [pbatf,pgridf,SOCfin]=function_storage(SOCmin,SOCin,prod_december(cont_i),cons_agosto(cont_i),Cbat,Pmax,etacd);
        pbat(cont_i)=pbatf;
        pgrid(cont_i)=pgridf;
        SOC(cont_i)=SOCfin;
        SOCin=SOCfin;
            end
        
        end
    end
    end
    
    %check per vedere se mi trovo nel caso 3
    
    if k>=2 && giorno>1
    if  bilancioprod(2,giorno)<0 && bilancioprod(2,giorno-1)>0
           
            Ebatdis6=Ebatdis18(k-1)+bilancioprod(3,giorno-1)+bilancioprod(1,giorno);
        if Ebatdis6<0
            Ebatdis6=0;
        end
     if Ebatdis6/suddivisione_carico(2,giorno)+rapp_prod_carico(giorno)<rapp_PVbat_carico
       
            for cont_i=minuto+1:minuto+720
            if cons_agosto(cont_i)>P_peak && cons_agosto(cont_i)>prod_december(cont_i)
                if prod_december(cont_i)<=P_peak
            pgrid(cont_i)=prod_december(cont_i)-P_peak;
            pbat(cont_i)=P_peak-cons_agosto(cont_i);
            if pbat(cont_i)<-Pmax
                pbat(cont_i)=-Pmax;
                pgrid(cont_i)=pgrid(cont_i)-cons_agosto(cont_i)+P_peak+Pmax;
            end
            SOC(cont_i)=SOC(cont_i-1)+(1/(etacd*60*Cbat))*(pbat(cont_i));
            if SOC(cont_i)<selectSOCmin
                pbat(cont_i)=(selectSOCmin-SOC(cont_i-1))*Cbat*60*etacd;
                pgrid(cont_i)=pgrid(cont_i)+(SOC(cont_i)-selectSOCmin)*Cbat*60*etacd;
                SOC(cont_i)=selectSOCmin;
            end
        else
            pbat(cont_i)=prod_december(cont_i)-cons_agosto(cont_i);
            if pbat(cont_i)<-Pmax
                pbat(cont_i)=-Pmax;
                pgrid(cont_i)=prod_december(cont_i)-cons_agosto(cont_i)+Pmax;
            end
            SOC(cont_i)=SOC(cont_i-1)+(1/(etacd*60*Cbat))*(pbat(cont_i));
            if SOC(cont_i)<selectSOCmin
                pbat(cont_i)=(selectSOCmin-SOC(cont_i-1))*Cbat*60*etacd;
                pgrid(cont_i)=pgrid(cont_i)+(SOC(cont_i)-selectSOCmin)*Cbat*60*etacd;
                 SOC(cont_i)=selectSOCmin;
            end
                end
            end
    if cons_agosto(cont_i)<=P_peak && cons_agosto(cont_i)>prod_december(cont_i)
        pbat(cont_i)=0;
        SOC(cont_i)=SOC(cont_i-1);
        pgrid(cont_i)=prod_december(cont_i)-cons_agosto(cont_i);
    end
    if cons_agosto(cont_i)<prod_december(cont_i)
        pbat(cont_i)=prod_december(cont_i)-cons_agosto(cont_i);
        SOC(cont_i)=SOC(cont_i-1)+(etacd/(60*Cbat))*(pbat(cont_i));
        if SOC(cont_i)>1
            pbat(cont_i)=(1-SOC(cont_i-1))*Cbat*(60/etacd);
             pgrid(cont_i)=pgrid(cont_i)+(SOC(cont_i)-1)*Cbat*(60/etacd);
             SOC(cont_i)=1;
        end
    end
    if cons_agosto(cont_i)==prod_december(cont_i)
        pbat(cont_i)=0;
        pgrid(cont_i)=0;
        SOC(cont_i)=SOC(cont_i-1);
    end
        
            end
    
        
        
            
            SOCin=SOC(minuto+720);
            SOCmin=0.2;
            for cont_i=minuto+721:minuto+1440
                [pbatf,pgridf,SOCfin]=function_storage(SOCmin,SOCin,prod_december(cont_i),cons_agosto(cont_i),Cbat,Pmax,etacd);
        pbat(cont_i)=pbatf;
        pgrid(cont_i)=pgridf;
        SOC(cont_i)=SOCfin;
        SOCin=SOCfin;
            end
        
    end
    end
    end
   
    
    
    if k>=2 && giorno>1
        if  bilancioprod(2,giorno)<0 && bilancioprod(2,giorno-1)<0
        if Ebatdis18(k)==0
            
            
            SOCin=SOC(minuto);
            SOCmin=selectSOCmin;
             
            for cont_i=minuto+1:minuto+1440
            
    [pbatf,pgridf,SOCfin]=function_storage(SOCmin,SOCin,prod_december(cont_i),cons_agosto(cont_i),Cbat,Pmax,etacd);
        pbat(cont_i)=pbatf;
        pgrid(cont_i)=pgridf;
        SOC(cont_i)=SOCfin;
        SOCin=SOCfin;
        
        
            end
        end
        end
    end
    
    
    k=k+1;
        
        
end



SOCin=SOC(44280);
for minuto=44281:44640 %standard management per 18-24 del'ultimo giorno del mese
    SOCmin=selectSOCmin;
             [pbatf,pgridf,SOCfin]=function_storage(SOCmin,SOCin,prod_december(minuto),cons_agosto(minuto),Cbat,Pmax,etacd);
        pbat(minuto)=pbatf;
        pgrid(minuto)=pgridf;
        SOC(minuto)=SOCfin;
        SOCin=SOCfin;
end


    
    
    for cont_i=1:1:44640 %management standard
        pbat1(cont_i)=prod_december(cont_i)-cons_agosto(cont_i);
    
    if pbat1(cont_i)>Pmax
        pgrid1(cont_i)=pbat1(cont_i)-Pmax;
        
        pbat1(cont_i)=Pmax;
    end
    
    if pbat1(cont_i)<-Pmax
        pbat1(cont_i)=-Pmax;
        pgrid1(cont_i)=prod_december(cont_i)-cons_agosto(cont_i)+Pmax;
    end
    
    
     if pbat1(cont_i)>0
    if cont_i==1
        SOC1(cont_i)=1+(etacd/(60*Cbat))*(pbat1(cont_i));
    else
        SOC1(cont_i)=SOC1(cont_i-1)+(etacd/(60*Cbat))*(pbat1(cont_i));
    end
    elseif pbat1(cont_i)<0
    if cont_i==1
        SOC1(cont_i)=1+(1/(etacd*60*Cbat))*(pbat1(cont_i));
    else
        SOC1(cont_i)=SOC1(cont_i-1)+(1/(etacd*60*Cbat))*(pbat1(cont_i));
    end
    end
     if pbat1(cont_i)==0
         if cont_i==1
             SOC1(cont_i)=1;
         else
             SOC1(cont_i)=SOC1(cont_i-1);
         end
     end
    
    
    
    if SOC1(cont_i)>1
       
        
        if cont_i==1
            pbat1(cont_i)=0;
        else
            pbat1(cont_i)=(1-SOC1(cont_i-1))*Cbat*(60/etacd);
        end
        
        pgrid1(cont_i)=pgrid1(cont_i)+(SOC1(cont_i)-1)*Cbat*(60/etacd);
        SOC1(cont_i)=1;
    end
    
    if SOC1(cont_i)<selectSOCmin
        
        if cont_i==1
            pbat1(cont_i)=(selectSOCmin-1)*Cbat*60*etacd;
        else
            pbat1(cont_i)=(selectSOCmin-SOC1(cont_i-1))*Cbat*60*etacd;
        end
        
        
        pgrid1(cont_i)=pgrid1(cont_i)+(SOC1(cont_i)-selectSOCmin)*Cbat*60*etacd;
        SOC1(cont_i)=selectSOCmin;
    end  
        
    end    



figure
plot(1:1:44640,SOC(1:1:44640))
hold on
plot(1:1:44640,SOC1(1:1:44640))

legend('modified management','standard management')
figure
plot(1:1:44640,pbat(1:1:44640))
legend('Power battery')



figure
plot(1:1:44640,pgrid(1:1:44640))

hold on
plot(1:1:44640,pgrid1(1:1:44640))
legend('pgrid modified management','pgrid standard management')


figure
plot(1440*15+1:1:1440*16,prod_december(1440*15+1:1:1440*16))
hold on
plot(1440*15+1:1:1440*16,cons_agosto(1440*15+1:1:1440*16))
hold on
plot(1440*15+1:1:1440*16,pbat(1440*15+1:1:1440*16))
hold on
plot(1440*15+1:1:1440*16,pgrid(1440*15+1:1:1440*16))
legend('FV','load','battery','grid')

figure
plot(1440*15+1:1:1440*16,prod_december(1440*15+1:1:1440*16))
hold on
plot(1440*15+1:1:1440*16,cons_agosto(1440*15+1:1:1440*16))
hold on
plot(1440*15+1:1:1440*16,pbat1(1440*15+1:1:1440*16))
hold on
plot(1440*15+1:1:1440*16,pgrid1(1440*15+1:1:1440*16))
legend('FV','load','battery1','grid1')

figure
plot(1440*27+1:1:1440*28,prod_december(1440*27+1:1:1440*28))
hold on
plot(1440*27+1:1:1440*28,cons_agosto(1440*27+1:1:1440*28))
hold on
plot(1440*27+1:1:1440*28,pbat(1440*27+1:1:1440*28))
hold on
plot(1440*27+1:1:1440*28,pgrid(1440*27+1:1:1440*28))
legend('FV','load','battery','grid')

egrid=sum(pgrid)/60;
egrid1=sum(pgrid1)/60;

egridassorbita=0;
for cont_i=1:length(pgrid)
    if pgrid(cont_i)<0
egridassorbita=egridassorbita+pgrid(cont_i);
    end
end
egridassorbita=egridassorbita/60;

egridceduta=0;
for cont_i=1:length(pgrid)
    if pgrid(cont_i)>0
egridceduta=egridceduta+pgrid(cont_i);
    end
end
egridceduta=egridceduta/60;

egridassorbita1=0;
for cont_i=1:length(pgrid1)
    if pgrid1(cont_i)<0
egridassorbita1=egridassorbita1+pgrid1(cont_i);
    end
end
egridassorbita1=egridassorbita1/60;

egridceduta1=0;
for cont_i=1:length(pgrid1)
    if pgrid1(cont_i)>0
egridceduta1=egridceduta1+pgrid1(cont_i);
    end
end
egridceduta1=egridceduta1/60;

resume=zeros(15,32);

resume1=zeros(15,32);
Ebatscar6=zeros(1,31);
caso3_4=zeros(1,31);
caso2=zeros(1,30);
pbatt_day=reshape(pbat, [1440 31]);
SOC_day=reshape(SOC, [1440 31]);
for cont_i=1:1:31
    Ebatscar6(cont_i)=(SOC_day(360,cont_i)-selectSOCmin)*Cbat;
    caso3_4(cont_i)=Ebatscar6(cont_i)/suddivisione_carico(2,cont_i)+rapp_prod_carico(cont_i);
end
for cont_i=1:1:30
    caso2(cont_i)=Ebatdis18(cont_i)/(suddivisione_carico(3,cont_i)+suddivisione_carico(1,cont_i+1));
end
pgrid_day=reshape(pgrid, [1440 31]);
pbatt_day1=reshape(pbat1, [1440 31]);
pgrid_day1=reshape(pgrid1, [1440 31]);
minpgrid=zeros(1,31);
maxpgrid=zeros(1,31);
for cont_i=1:1:31
    minpgrid(cont_i)=min(pgrid_day(:,cont_i));
    maxpgrid(cont_i)=max(pgrid_day(:,cont_i));
end


%self consumption
for cont_j=1:1:31
    for cont_i=1:1:1440
        if pgrid_day(cont_i,cont_j)<0
            resume(1,cont_j)=resume(1,cont_j)+(1/60)*mese_agosto(cont_i,cont_j)+(1/60)*pgrid_day(cont_i,cont_j);
        end
        if pgrid_day(cont_i,cont_j)==0
            resume(1,cont_j)=resume(1,cont_j)+(1/60)*mese_agosto(cont_i,cont_j);
        end
        if pgrid_day(cont_i,cont_j)>0
            resume(1,cont_j)=resume(1,cont_j)+(1/60)*mese_agosto(cont_i,cont_j)-(1/60)*pgrid_day(cont_i,cont_j);
        end
    end
end
 
for cont_i=1:1:31
    resume(1,32)=resume(1,32)+resume(1,cont_i);
end


%absorbtion from grid and injection to the grid
for cont_j=1:1:31
    for cont_i=1:1:1440
        if pgrid_day(cont_i,cont_j)<0
            resume(2,cont_j)=resume(2,cont_j)-(1/60)*pgrid_day(cont_i,cont_j);
        end
        if pgrid_day(cont_i,cont_j)>0
            resume(3,cont_j)=resume(3,cont_j)+(1/60)*pgrid_day(cont_i,cont_j);
        end
        
    end
end

for cont_i=1:1:31
    resume(2,32)=resume(2,32)+resume(2,cont_i);
end
for cont_i=1:1:31
    resume(3,32)=resume(3,32)+resume(3,cont_i);
end



for cont_i=1:1:31
    
    resume(4,cont_i)=resume(1,cont_i)/load1(cont_i);
    resume(5,cont_i)=resume(1,cont_i)/generazione(cont_i);
    resume(6,cont_i)=resume(3,cont_i)/load1(cont_i);
end
    
resume(4,32)=resume(1,32)/sum(load1);
resume(5,32)=resume(1,32)/sum(generazione);
resume(6,32)=resume(3,32)/sum(load1);

trt=max(pgrid);
rrf=max(pgrid1);

for cont_j=1:1:31
    for cont_i=1:1:1440
    if pgrid_day(cont_i,cont_j)<0 && pgrid_day(cont_i,cont_j)>=-0.5
    resume(7,cont_j)=resume(7,cont_j)+1;
    end
    if pgrid_day(cont_i,cont_j)<-0.5 && pgrid_day(cont_i,cont_j)>=-1
    resume(8,cont_j)=resume(8,cont_j)+1;
    end
    if pgrid_day(cont_i,cont_j)<-1 && pgrid_day(cont_i,cont_j)>=-1.5
    resume(9,cont_j)=resume(9,cont_j)+1;
    end
    if pgrid_day(cont_i,cont_j)<-1.5 && pgrid_day(cont_i,cont_j)>=-2
    resume(10,cont_j)=resume(10,cont_j)+1;
    end
    if pgrid_day(cont_i,cont_j)<-2 && pgrid_day(cont_i,cont_j)>=-2.5
    resume(11,cont_j)=resume(11,cont_j)+1;
    end
    if pgrid_day(cont_i,cont_j)<-2.5 && pgrid_day(cont_i,cont_j)>=-3
    resume(12,cont_j)=resume(12,cont_j)+1;
    end
    if pgrid_day(cont_i,cont_j)<-3 && pgrid_day(cont_i,cont_j)>=-3.5
    resume(13,cont_j)=resume(13,cont_j)+1;
    end
    if pgrid_day(cont_i,cont_j)<-3.5 && pgrid_day(cont_i,cont_j)>=-4
    resume(14,cont_j)=resume(14,cont_j)+1;
    end 
    if pgrid_day(cont_i,cont_j)<-4
    resume(15,cont_j)=resume(15,cont_j)+1;
    end 
    
    
    end
end
for cont_i=1:1:31
   
    resume(7,32)=resume(7,32)+resume(7,cont_i);
    resume(8,32)=resume(8,32)+resume(8,cont_i);
    resume(9,32)=resume(9,32)+resume(9,cont_i);
    resume(10,32)=resume(10,32)+resume(10,cont_i);
    resume(11,32)=resume(11,32)+resume(11,cont_i);
    resume(12,32)=resume(12,32)+resume(12,cont_i);
    resume(13,32)=resume(13,32)+resume(13,cont_i);
    resume(14,32)=resume(14,32)+resume(14,cont_i);
    resume(15,32)=resume(15,32)+resume(15,cont_i);
end  
 

%self consumption
for cont_j=1:1:31
    for cont_i=1:1:1440
        if pgrid_day1(cont_i,cont_j)<0
            resume1(1,cont_j)=resume1(1,cont_j)+(1/60)*mese_agosto(cont_i,cont_j)+(1/60)*pgrid_day1(cont_i,cont_j);
        end
        if pgrid_day1(cont_i,cont_j)==0
            resume1(1,cont_j)=resume1(1,cont_j)+(1/60)*mese_agosto(cont_i,cont_j);
        end
        if pgrid_day1(cont_i,cont_j)>0
            resume1(1,cont_j)=resume1(1,cont_j)+(1/60)*mese_agosto(cont_i,cont_j)-(1/60)*pgrid_day1(cont_i,cont_j);
        end
    end
end    

for cont_i=1:1:31
    resume1(1,32)=resume1(1,32)+resume1(1,cont_i);
end

 
%absorbtion from grid and injection to the grid
for cont_j=1:1:31
    for cont_i=1:1:1440
        if pgrid_day1(cont_i,cont_j)<0
            resume1(2,cont_j)=resume1(2,cont_j)-(1/60)*pgrid_day1(cont_i,cont_j);
        end
        if pgrid_day1(cont_i,cont_j)>0
            resume1(3,cont_j)=resume1(3,cont_j)+(1/60)*pgrid_day1(cont_i,cont_j);
        end
        
    end
end

for cont_i=1:1:31
    resume1(2,32)=resume1(2,32)+resume1(2,cont_i);
end
for cont_i=1:1:31
    resume1(3,32)=resume1(3,32)+resume1(3,cont_i);
end




for cont_i=1:1:31
    
    resume1(4,cont_i)=resume1(1,cont_i)/load1(cont_i);
    resume1(5,cont_i)=resume1(1,cont_i)/generazione(cont_i);
    resume1(6,cont_i)=resume1(3,cont_i)/load1(cont_i);
end
        
resume1(4,32)=resume1(1,32)/sum(load1);
resume1(5,32)=resume1(1,32)/sum(generazione);
resume1(6,32)=resume1(3,32)/sum(load1);


for cont_j=1:1:31
    for cont_i=1:1:1440
    if pgrid_day1(cont_i,cont_j)<0 && pgrid_day1(cont_i,cont_j)>=-0.5
    resume1(7,cont_j)=resume1(7,cont_j)+1;
    end
    if pgrid_day1(cont_i,cont_j)<-0.5 && pgrid_day1(cont_i,cont_j)>=-1
    resume1(8,cont_j)=resume1(8,cont_j)+1;
    end
    if pgrid_day1(cont_i,cont_j)<-1 && pgrid_day1(cont_i,cont_j)>=-1.5
    resume1(9,cont_j)=resume1(9,cont_j)+1;
    end
    if pgrid_day1(cont_i,cont_j)<-1.5 && pgrid_day1(cont_i,cont_j)>=-2
    resume1(10,cont_j)=resume1(10,cont_j)+1;
    end
    if pgrid_day1(cont_i,cont_j)<-2 && pgrid_day1(cont_i,cont_j)>=-2.5
    resume1(11,cont_j)=resume1(11,cont_j)+1;
    end
    if pgrid_day1(cont_i,cont_j)<-2.5 && pgrid_day1(cont_i,cont_j)>=-3
    resume1(12,cont_j)=resume1(12,cont_j)+1;
    end
    if pgrid_day1(cont_i,cont_j)<-3 && pgrid_day1(cont_i,cont_j)>=-3.5
    resume1(13,cont_j)=resume1(13,cont_j)+1;
    end
    if pgrid_day1(cont_i,cont_j)<-3.5 && pgrid_day1(cont_i,cont_j)>=-4
    resume1(14,cont_j)=resume1(14,cont_j)+1;
    end 
    if pgrid_day1(cont_i,cont_j)<-4
    resume1(15,cont_j)=resume1(15,cont_j)+1;
    end 
    
    
    end
end

for cont_i=1:1:31
   
    resume1(7,32)=resume1(7,32)+resume1(7,cont_i);
    resume1(8,32)=resume1(8,32)+resume1(8,cont_i);
    resume1(9,32)=resume1(9,32)+resume1(9,cont_i);
    resume1(10,32)=resume1(10,32)+resume1(10,cont_i);
    resume1(11,32)=resume1(11,32)+resume1(11,cont_i);
    resume1(12,32)=resume1(12,32)+resume1(12,cont_i);
    resume1(13,32)=resume1(13,32)+resume1(13,cont_i);
    resume1(14,32)=resume1(14,32)+resume1(14,cont_i);
    resume1(15,32)=resume1(15,32)+resume1(15,cont_i);
end  
 

monthly_sc_modmanag=sum(resume(1,:));
monthly_sc_stdmanag=sum(resume1(1,:));
toc
figure

for cont_i=1:2:5
subplot(3,2,cont_i)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pbat(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
legend('FV','load','battery','grid')
title(['Day',num2str((cont_i+1)/2),'modified'])

end
hold on
for cont_i=2:2:6
subplot(3,2,cont_i)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pbat1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
legend('FV','load','battery1','grid1')
title(['Day',num2str((cont_i)/2),'standard'])

end

figure
for cont_i=7:2:11
subplot(3,2,cont_i-6)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pbat(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i+1)/2),'modified'])
end
hold on
for cont_i=8:2:12
subplot(3,2,cont_i-6)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pbat1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i)/2),'standard'])
end
figure
for cont_i=13:2:17
subplot(3,2,cont_i-12)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pbat(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i+1)/2),'modified'])
end
hold on
for cont_i=14:2:18
subplot(3,2,cont_i-12)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pbat1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i)/2),'standard'])
end
figure
for cont_i=19:2:23
subplot(3,2,cont_i-18)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pbat(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i+1)/2),'modified'])
end
hold on
for cont_i=20:2:24
subplot(3,2,cont_i-18)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pbat1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i)/2),'standard'])
end
figure
for cont_i=25:2:29
subplot(3,2,cont_i-24)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pbat(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i+1)/2),'modified'])
end
hold on
for cont_i=26:2:30
subplot(3,2,cont_i-24)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pbat1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i)/2),'standard'])
end
figure
for cont_i=31:2:35
subplot(3,2,cont_i-30)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pbat(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i+1)/2),'modified'])
end
hold on
for cont_i=32:2:36
subplot(3,2,cont_i-30)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pbat1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i)/2),'standard'])
end
figure
for cont_i=37:2:41
subplot(3,2,cont_i-36)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pbat(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i+1)/2),'modified'])


end
hold on
for cont_i=38:2:42
subplot(3,2,cont_i-36)
plot(1/60:1/60:1440/60,prod_december(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pbat1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i)/2),'standard'])
end
figure
for cont_i=43:2:47
subplot(3,2,cont_i-42)
plot(1/60:1/60:1440/60,prod_december(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pbat(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i+1)/2),'modified'])

end
hold on
for cont_i=44:2:48
subplot(3,2,cont_i-42)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pbat1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i)/2),'standard'])
end
figure
for cont_i=49:2:53
subplot(3,2,cont_i-48)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pbat(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i+1)/2),'modified'])
end
hold on
for cont_i=50:2:54
subplot(3,2,cont_i-48)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pbat1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i)/2),'standard'])

end
figure
for cont_i=55:2:59
subplot(3,2,cont_i-54)

plot(1/60:1/60:1440/60,prod_december(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pbat(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i+1)/2),'modified'])

end
hold on
for cont_i=56:2:60
subplot(3,2,cont_i-54)
plot(1/60:1/60:1440/60,prod_december(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,cons_agosto(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pbat1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
hold on
plot(1/60:1/60:1440/60,pgrid1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))
xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('Power(kW)')
title(['Day',num2str((cont_i)/2),'standard'])
end

figure
for cont_i=1:2:5
subplot(3,2,cont_i)

plot(1/60:1/60:1440/60,SOC(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))

xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i+1)/2),'modified'])
end
hold on
for cont_i=2:2:6
subplot(3,2,cont_i)

plot(1/60:1/60:1440/60,SOC1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))


xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i)/2),'standard'])

end

figure
for cont_i=7:2:11
subplot(3,2,cont_i-6)


plot(1/60:1/60:1440/60,SOC(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))

xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i+1)/2),'modified'])

end
hold on
for cont_i=8:2:12
subplot(3,2,cont_i-6)

plot(1/60:1/60:1440/60,SOC1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))


xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i)/2),'standard'])
end
figure
for cont_i=13:2:17
subplot(3,2,cont_i-12)
plot(1/60:1/60:1440/60,SOC(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))

xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i+1)/2),'modified'])
end
hold on
for cont_i=14:2:18
subplot(3,2,cont_i-12)
plot(1/60:1/60:1440/60,SOC1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))


xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i)/2),'standard'])
end
figure
for cont_i=19:2:23
subplot(3,2,cont_i-18)
plot(1/60:1/60:1440/60,SOC(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))

xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i+1)/2),'modified'])
end
hold on
for cont_i=20:2:24
subplot(3,2,cont_i-18)

plot(1/60:1/60:1440/60,SOC1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))


xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i)/2),'standard'])
end
figure
for cont_i=25:2:29
subplot(3,2,cont_i-24)
plot(1/60:1/60:1440/60,SOC(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))

xlim([1/60,1440/60])

xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i+1)/2),'modified'])
end
hold on
for cont_i=26:2:30
subplot(3,2,cont_i-24)
plot(1/60:1/60:1440/60,SOC1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))


xlim([1/60,1440/60])

xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i)/2),'standard'])
end
figure
for cont_i=31:2:35
subplot(3,2,cont_i-30)
plot(1/60:1/60:1440/60,SOC(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))

xlim([1/60,1440/60])

xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i+1)/2),'modified'])
end
hold on
for cont_i=32:2:36
subplot(3,2,cont_i-30)

plot(1/60:1/60:1440/60,SOC1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))


xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i)/2),'standard'])

end
figure
for cont_i=37:2:41
subplot(3,2,cont_i-36)

plot(1/60:1/60:1440/60,SOC(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))

xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i+1)/2),'modified'])



end
hold on
for cont_i=38:2:42
subplot(3,2,cont_i-36)

plot(1/60:1/60:1440/60,SOC1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))


xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i)/2),'standard'])
end
figure
for cont_i=43:2:47
subplot(3,2,cont_i-42)

plot(1/60:1/60:1440/60,SOC(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))

xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i+1)/2),'modified'])
end
hold on
for cont_i=44:2:48
subplot(3,2,cont_i-42)

plot(1/60:1/60:1440/60,SOC1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))


xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i)/2),'standard'])

end
figure
for cont_i=49:2:53
subplot(3,2,cont_i-48)

plot(1/60:1/60:1440/60,SOC(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))

xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i+1)/2),'modified'])
end
hold on
for cont_i=50:2:54
subplot(3,2,cont_i-48)
plot(1/60:1/60:1440/60,SOC1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))


xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i)/2),'standard'])


end
figure
for cont_i=55:2:59
subplot(3,2,cont_i-54)

plot(1/60:1/60:1440/60,SOC(1440*((cont_i+1)/2-1)+1:1:1440*((cont_i+1)/2)))

xlim([1/60,1440/60])
xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i+1)/2),'modified'])
end
hold on
for cont_i=56:2:60
subplot(3,2,cont_i-54)
plot(1/60:1/60:1440/60,SOC1(1440*((cont_i)/2-1)+1:1:1440*((cont_i)/2)))


xlim([1/60,1440/60])

xlabel('time(h)')
ylabel('SOC')
title(['Day',num2str((cont_i)/2),'standard'])
end


figure

histogram(pgrid,4,'BinLimits',[-4.5 -2.5])
hold on
histogram(pgrid1,4,'BinLimits',[-4.5 -2.5],'FaceAlpha',0.5)
title('Power absorbed from grid: occurencies')
legend('Modified BMS','Standard BMS')

figure

histogram(pgrid,4,'BinLimits',[-2.5 -0.5])
hold on
histogram(pgrid1,4,'BinLimits',[-2.5 -0.5])

legend('Modified BMS','Standard BMS')

figure
histogram(pgrid,8,'BinLimits',[-4.5 -0.5])
hold on
histogram(pgrid1,8,'BinLimits',[-4.5 -0.5])
title('Power absorbed from grid: occurencies')
legend('Modified BMS','Standard BMS')

casostd=min(pgrid1);
casomod=min(pgrid);

rd=20161:1:23399;
tj=1/60:1/60:1800/60;
figure
plot(1/60:1/60:3240/60,prod_december(20161:1:23400),'linewidth',1.5)
hold on
plot(1/60:1/60:3240/60,cons_agosto(20161:1:23400),'linewidth',1.5)
hold on
plot(1/60:1/60:3240/60,pbat(20161:1:23400),'linewidth',1.5)
hold on
plot(1/60:1/60:3240/60,pgrid(20161:1:23400),'linewidth',1.5)
xlabel('time(h)')
ylabel('Power(kW)')
title('Modified BMS from 0AM 15/12 to 6PM 17/12')
xlim([1/60 3240/60])
ylim([-5 5])
legend('FV','load','battery','grid')

figure

plot(1/60:1/60:3240/60,prod_december(20161:1:23400),'linewidth',1.5)
hold on
plot(1/60:1/60:3240/60,cons_agosto(20161:1:23400),'linewidth',1.5)
hold on
plot(1/60:1/60:3240/60,pbat1(20161:1:23400),'linewidth',1.5)
hold on
plot(1/60:1/60:3240/60,pgrid1(20161:1:23400),'linewidth',1.5)
xlabel('time(h)')
ylabel('Power(kW)')
title('Standard BMS from 0AM 15/12 to 6PM 17/12')
legend('FV','load','battery','grid')
ylim([-5 5])
xlim([1/60 3240/60])

figure
plot(1/60:1/60:3240/60,SOC(20161:1:23400),'linewidth',1.5)
xlabel('time(h)')
ylabel('SOC')
title('Modified BMS')
legend('SOC')
xlim([1/60 3240/60])


figure
plot(1/60:1/60:3240/60,SOC1(20161:1:23400),'linewidth',1.5)
xlabel('time(h)')
ylabel('SOC')
title('Standard BMS')
legend('SOC')
xlim([1/60 3240/60])


figure

plot(1/60:1/60:2520/60,prod_december(11521:1:14040),'linewidth',1.5)
hold on
plot(1/60:1/60:2520/60,cons_agosto(11521:1:14040),'linewidth',1.5)
hold on
plot(1/60:1/60:2520/60,pbat(11521:1:14040),'linewidth',1.5)
hold on
plot(1/60:1/60:2520/60,pgrid(11521:1:14040),'linewidth',1.5)
xlabel('time(h)')
ylabel('Power(kW)')
title('Standard and Modified BMS from 0AM 9/12 to 6PM 10/12')
legend('PV','load','battery','grid')
xlim([1/60 2520/60])

figure
plot(1/60:1/60:2520/60,SOC(11521:1:14040),'linewidth',1.5)
xlabel('time(h)')
ylabel('SOC')
title('Standard BMS')
title('Standard and Modified BMS from 0AM 9/12 to 6PM 10/12')
legend('SOC')
xlim([1/60 2520/60])

figure

plot(1/60:1/60:2520/60,prod_december(8641:1:11160),'linewidth',1.5)
hold on
plot(1/60:1/60:2520/60,cons_agosto(8641:1:11160),'linewidth',1.5)
hold on
plot(1/60:1/60:2520/60,pbat(8641:1:11160),'linewidth',1.5)
hold on
plot(1/60:1/60:2520/60,pgrid(8641:1:11160),'linewidth',1.5)
xlabel('time(h)')
ylabel('Power(kW)')
title('Modified BMS from 0AM 7/12 to 6PM 8/12')
legend('PV','load','battery','grid')
xlim([1/60 2520/60])

figure

plot(1/60:1/60:2520/60,prod_december(8641:1:11160),'linewidth',1.5)
hold on
plot(1/60:1/60:2520/60,cons_agosto(8641:1:11160),'linewidth',1.5)
hold on
plot(1/60:1/60:2520/60,pbat1(8641:1:11160),'linewidth',1.5)
hold on
plot(1/60:1/60:2520/60,pgrid1(8641:1:11160),'linewidth',1.5)
xlabel('time(h)')
ylabel('Power(kW)')
title('Standard BMS from 0AM 7/12 to 6AM 8/12')
legend('PV','load','battery','grid')
xlim([1/60 2520/60])

figure
plot(1/60:1/60:2520/60,SOC(8641:1:11160),'linewidth',1.5)
xlabel('time(h)')
ylabel('SOC')

title('Modified BMS from 0AM 7/12 to 6AM 8/12')
legend('SOC')
xlim([1/60 2520/60])

figure
plot(1/60:1/60:2520/60,SOC1(8641:1:11160),'linewidth',1.5)
xlabel('time(h)')
ylabel('SOC')

title('Standard BMS from 0AM 7/12 to 6AM 8/12')
legend('SOC')
xlim([1/60 2520/60])

figure
subplot(2,1,1)
histogram(pgrid,8,'BinLimits',[-4.5 -0.5])
legend('Modified BMS')
subplot(2,1,2)
histogram(pgrid1,8,'BinLimits',[-4.5 -0.5],'FaceColor','r')
legend('Standard BMS')

figure
plot(1/60:1/60:2160/60,SOC(2521:4680),'linewidth',1.5)
xlim([1/60 2160/60])
legend('SOC')
title('Modified BMS from 6PM of 2/12 to 6AM of 4/12')

figure
plot(1/60:1/60:2160/60,SOC1(2521:4680),'linewidth',1.5)
xlim([1/60 2160/60])
legend('SOC')
title('Standard BMS from 6PM of 2/12 to 6AM of 4/12')




